/*******************************************************************************
 Graph Project
 Copyright (C) 2006  denton

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 ********************************************************************************
 File: src/Graph.java
 Version: 0.1.0  Date: 27.07.2006
 Author: denton
 *******************************************************************************/

package Graph;

import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import javax.microedition.rms.*;

public class Graph extends MIDlet implements CommandListener {
    
    private Command exitCommand; 
    private Command okCommand;
    private Command changeCommand;
    private Command cancelCommand;
    private Command optionsCommand;
    private Command helpCommand;
    private Command calcCommand;
    private Command okcalcCommand;
    private Command morecalcCommand;
    
    boolean dochange = true;
    boolean firstlaunch = true;
    
    static byte lng =1 ;
    static String calcs = "";
    
    TextBox t,ct;
    Canvas canvas;
    Gauge g;
    ChoiceGroup lang, turn;
    Form opts,calcres,helpf;
    
    static public Display display;


    public void initcommands() {
        okCommand = new Command(Lang.S[lng][0], Command.OK, 0);
        changeCommand = new Command(Lang.S[lng][1], Command.BACK, 1);
        cancelCommand = new Command(Lang.S[lng][2], Command.BACK, 1);
        optionsCommand = new Command(Lang.S[lng][3], Command.SCREEN, 2);
        helpCommand = new Command(Lang.S[lng][4], Command.HELP, 3);
        exitCommand = new Command(Lang.S[lng][5], Command.SCREEN, 8);
        calcCommand = new Command(Lang.S[lng][14], Command.ITEM, 4);
        morecalcCommand = new Command(Lang.S[lng][16], Command.ITEM, 4);
        okcalcCommand = new Command(Lang.S[lng][0], Command.OK, 0);
    }
    
    public void createhelp() {
        helpf = new Form(Lang.S[lng][4]);
        helpf.append(Lang.S[lng][10]);
        helpf.append(Lang.S[lng][11]);
        
        helpf.addCommand(okCommand);
        helpf.setCommandListener(this);
        display.setCurrent(helpf);
    }
    
    public void createtbox() {
        t = new TextBox("y=", Canvas1.funct, 256, 0);
        t.addCommand(exitCommand);
        t.addCommand(okCommand);
        if (!firstlaunch) t.addCommand(cancelCommand);
        t.setCommandListener(this);
        display.setCurrent(t);
    }
    
    public void createoptions() {
        opts = new Form(Lang.S[lng][3]);
        g = new Gauge(Lang.S[lng][6], true, 5, Canvas1.mscale()-1);
        String[] strArray = {Lang.S[lng][7], Lang.S[lng][8]};
        lang = new ChoiceGroup(Lang.S[lng][9],ChoiceGroup.EXCLUSIVE,strArray,null);
        lang.setSelectedIndex(lng,true);
        String[] ttrArray = {Lang.S[lng][12]};
        turn = new ChoiceGroup(Lang.S[lng][13],ChoiceGroup.MULTIPLE,ttrArray,null);
        turn.setSelectedIndex(0,Canvas1.turned);
        opts.append(g);
        opts.append(lang);
        opts.append(turn);
        opts.addCommand(okCommand);
        opts.addCommand(cancelCommand);
        opts.setCommandListener(this);
        display.setCurrent(opts);
        dochange = true;
    }
    
    public void createcalc() {
        ct = new TextBox(Lang.S[lng][15], calcs, 256, 0);
        ct.addCommand(cancelCommand);
        ct.addCommand(okcalcCommand);
        ct.setCommandListener(this);
        display.setCurrent(ct);
    }
    
    public void createokcalc() {
        calcres = new Form(calcs);
        String r = Parser.replaceBrackets(calcs);
        r = Parser.replaceConstants(r);
        try {
            r = Parser.calculate(r).toString();
            calcres.append(r);
        } catch (GraphException e) {calcres.append(e.getMessage());}
        
        calcres.addCommand(morecalcCommand);
        calcres.addCommand(okCommand);
        calcres.setCommandListener(this);
        display.setCurrent(calcres);
    }

    public void startApp() {
//        Record.readData();
        display = Display.getDisplay(this);
        initcommands();
        createtbox();
    }
    
    /**
     * Pause is a no-op since there are no background activities or
     * record stores that need to be closed.
     */
    public void pauseApp() {
    }
    
    public void destroyApp(boolean unconditional) {
//        try {Record.writeData();}
//          catch (RecordStoreException e) {System.out.println(e.getMessage());}
        notifyDestroyed();
    }
    
    public void commandAction(Command c, Displayable d) {
        if (c == exitCommand) destroyApp(false);
        if (c == okCommand) {
            
            if (d==t) {
                if (Canvas1.funct!=t.getString()) {
                    Canvas1.funct = t.getString();
                    Canvas1.drew = false;
                }
            }
            if ((d==opts)&dochange) {
                Canvas1.drew = true;
                byte tmpscale = 1;
                for (int i=1;i<g.getValue()+1;i++) {tmpscale*=2;}
                if (tmpscale!=Canvas1.scale) {
                    Canvas1.drew = false;
                    Canvas1.scale = tmpscale;
                    Canvas1.xshift = Canvas1.yshift = 0;
                }
                Integer tm = new Integer(lang.getSelectedIndex());
                if (lng!=tm.byteValue()) lng = tm.byteValue();
                if ((turn.isSelected(0))^(Canvas1.turned)) {
                    Canvas1.turned = turn.isSelected(0);
                    Canvas1.xshift = Canvas1.yshift=0;
                    Canvas1.drew = false;
                }
                initcommands();
            }
            if ((d==calcres)|(d==helpf)) Canvas1.drew = true;
            if (firstlaunch) firstlaunch = false;
            canvas = new Canvas1();
            Canvas1.width = canvas.getWidth();
            Canvas1.height = canvas.getHeight();
            if (Canvas1.width>=240) Canvas1.bigfont = true;
            canvas.addCommand(exitCommand);
            canvas.addCommand(changeCommand);
            canvas.addCommand(optionsCommand);
            canvas.addCommand(helpCommand);
            canvas.addCommand(calcCommand);
            canvas.setCommandListener(this);
            display.setCurrent(canvas);
        }

        if (c == cancelCommand) {
            if (d!=opts) t = new TextBox("y=", Canvas1.funct, 256, 0);
            dochange = false;
            commandAction(okCommand,d);
            dochange = true;
            Canvas1.drew = true;
        }
        if (c == okcalcCommand) {
            calcs = ct.getString();
            createokcalc();
        }
        if (c == changeCommand) createtbox();
        if (c == optionsCommand) createoptions();
        if (c == helpCommand) createhelp();
        if ((c == calcCommand)|(c == morecalcCommand)) createcalc();
    }
    
}
